image: haskell:8.10.3


stages:
  - misc
  - build
  - test


.cabal-cache:
  cache:
    key: "$CI_COMMIT_REF_SLUG"
    paths:
      - dist-newstyle/
      - cabal-cache
  before_script:
    - mv cabal-cache /root/.cabal || true
    - cabal new-update
  after_script:
    - mv /root/.cabal cabal-cache


lint:
  extends:
    - .cabal-cache
  stage: misc
  script:
    - cabal new-install --overwrite-policy=always hlint-3.3.1
    - ./lint.sh

doc:
  extends:
    - .cabal-cache
  stage: misc
  script:
    - cabal new-haddock

build-myott:
  extends:
    - .cabal-cache
  stage: build
  script:
    - cabal new-build


test-myott-e2e:
  extends:
    - .cabal-cache
  stage: test
  script:
    - ./test.sh
